--[[
Group O Matic, 2-21-08 (c). by Bryce Wilbur -- Anyone may use, modify, and/or redistribute this work, provided that this notice remains unmodified. This work may not be sold or included in any for-profit compilations.

0.0.1B (3-8-08): initial release

TODO:
user tamplates
add a mini GUI attached to RaidFrame
console command to change the arrangement throttle?
throttle on /rs and /rm ? (possibly using delayedactionqueue)
group swap (last action should reflect this) don't announce finish if it's set that way either
]]

GOMatic_RolesByNameCache = {}
GOMatic_SavedRaidLayouts = {}
GOMatic_AlwaysSure = false
GOMatic_Silent = false

GOMatic_Version_String = "0.0.1 Beta"

--set this to 0.xxx for betas
GOMatic_Version = 0.0001 -- this should only change if the talent check system is changed (because of a talent patch etc) or if there's some other reason for non-raid leaders to upgrade


GOMatic_ArrangementFrameUpdateThrottle = 0.3
GOMatic_ArrangementFrameBreakMaximum = 100
GOMatic_TalentRequestDelayMaximum = 5.0

GOMATIC_ARRANGE_BREAK = 0

GOMatic_SaveName = nil

local loc = GOMatic_Localization

local roleIndex = {
	["MAIN_TANK"] = 1,
	["TANK"] = 2,
	["TANK_BUFFER"] = 3,
	["HEALER"] = 4,
	["MANA_BATTERY"] = 5,
	["HEAL_BUFFER"] = 6,
	["MELEE_BUFFER"] = 7,
	["RANGE_BUFFER"] = 8,
	["SPELL_BUFFER"] = 9,
	["MELEE_DPS"] = 10,
	["RANGE_DPS"] = 11,
	["SPELL_DPS"] = 12
}

--index maps onto roles above
local defaultClassRoles = {
	["WARRIOR"] = {false, true, false, false, false, false, true, false, false, true, false, false},
	["DRUID"] = {false, false, false, true, false, true, false, false, false, false, false, false},
	["SHAMAN"] = {false, false, false, true, true, false, true, true, true, false, false, false},
	["MAGE"] = {false, false, false, false, false, false, false, false, false, false, false, true},
	["WARLOCK"] = {false, false, true, false, false, false, false, false, false, false, false, true},
	["ROGUE"] = {false, false, false, false, false, false, false, false, false, true, false, false},
	["HUNTER"] = {false, false, false, false, false, false, false, true, false, false, true, false},
	["PRIEST"] = {false, false, false, true, false, false, false, false, false, false, false, false},
	["PALADIN"] = {false, false, true, true, false, false, false, false, false, false, false, false}
}

--if one of these is true, it is true for ALL members of that class, false means SOME OR ALL members of that class do not play that role
local universalClassRoles = {
	["WARRIOR"] = {false, false, false, false, false, false, true, false, false, false, false, false},
	["DRUID"] = {false, false, false, false, false, false, false, false, false, false, false, false},
	["SHAMAN"] = {false, false, false, false, false, true, true, true, true, false, false, false},
	["MAGE"] = {false, false, false, false, false, false, false, false, false, false, false, true},
	["WARLOCK"] = {false, false, false, false, false, false, false, false, false, false, false, true},
	["ROGUE"] = {false, false, false, false, false, false, false, false, false, true, false, false},
	["HUNTER"] = {false, false, false, false, false, false, false, false, false, false, true, false},
	["PRIEST"] = {false, false, false, false, false, false, false, false, false, false, false, false},
	["PALADIN"] = {false, false, false, false, false, false, true, true, true, false, false, false}
}

--these map talents to their closest PRIMARY function...left to right top to bottom by tree
local tank, heal, melee, range, spell = 1, 2, 3, 4, 5
local mainRolesWarrior = {
	{melee,tank,melee,tank,tank,tank,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee},
	{tank,melee,tank,melee,melee,tank,tank,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee},
	{tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank}
}
local mainRolesDruid = {
	{spell,tank,tank,spell,spell,spell,spell,heal,tank,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell},
	{tank,tank,tank,tank,tank,tank,tank,melee,melee,melee,tank,melee,tank,heal,tank,tank,tank,melee,tank,tank,tank},
	{heal,tank,heal,heal,tank,heal,heal,tank,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal}
}
local mainRolesShaman = {
	{spell,spell,spell,heal,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,heal,spell,spell},
	{melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee}, --god damn this tree sucks...i'm not even going to bother reading all the descriptions -.-
	{heal,heal,heal,heal,heal,spell,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal}
}
local mainRolesMage = false --always spell dps

local mainRolesWarlock = false --always spell dps

local mainRolesRogue = false --always melee dps

local mainRolesHunter = false --always ranged dps

local mainRolesPriest = {
	{heal,spell,heal,heal,heal,heal,heal,heal,heal,spell,spell,spell,heal,heal,spell,spell,spell,spell,spell,spell,spell,spell},
	{heal,heal,heal,spell,spell,heal,spell,heal,spell,heal,spell,heal,heal,heal,spell,heal,heal,heal,spell,heal,heal},
	{spell,spell,spell,spell,spell,spell,spell,spell,heal,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell}
}
local mainRolesPaladin = {
	{melee,heal,heal,melee,heal,heal,heal,heal,heal,heal,tank,heal,heal,heal,heal,heal,heal,tank,heal,heal},
	{tank,tank,tank,heal,tank,heal,tank,tank,tank,tank,tank,spell,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank},
	{melee,melee,melee,melee,tank,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,tank,melee,melee}
}

local talentsToMainRolesByClass = {
	["WARRIOR"] = mainRolesWarrior,
	["DRUID"] = mainRolesDruid,
	["SHAMAN"] = mainRolesShaman,
	["MAGE"] = mainRolesMage,
	["WARLOCK"] = mainRolesWarlock,
	["ROGUE"] = mainRolesRogue,
	["HUNTER"] = mainRolesHunter,
	["PRIEST"] = mainRolesPriest,
	["PALADIN"] = mainRolesPaladin
}	

local talentsToSpecialRolesByClass = {
	["WARRIOR"] = {
		{},
		{[8]="MELEE_BUFFER"}, -- Commanding Presence -- Only considered if the warrior isn't placed in a tanking group
		{}
	},
	["DRUID"] = {
		{[18]="SPELL_BUFFER"}, --Moonkin Form
		{[18]="MELEE_BUFFER"}, --Leader of the Pack -- Only considered if the druid isn't placed in a tanking group
		{[20]="TANK_BUFFER"}   --Tree of Life
	},
	["SHAMAN"] = {
		{}, --shaman are already melee buffers by default so it doesn't matter
		{},
		{[16]="MANA_BATTERY"} --Mana Tide Totem
	},
	["MAGE"] = {
		{},
		{},
		{}
	},
	["WARLOCK"] = {
		{},
		{[2]="TANK_BUFFER"}, --Improved Imp -- These warlocks get priority for tank groups
		{}
	},
	["ROGUE"] = {
		{},
		{},
		{}
	},
	["HUNTER"] = {
		{[17]="RANGE_BUFFER"}, --Ferocious Inspiration -- Melee will get put in this group also if there are no available melee groups or other ranged for this group
		{[17]="RANGE_BUFFER"}, --Trueshot Aura -- Melee will get put in this group also if there are no available melee groups or other ranged for this group
		{}
	},
	["PRIEST"] = {
		{},
		{},
		{[13]="TANK_BUFFER",[21]="MANA_BATTERY"} --VE and VT -- VT is considered first for group placement
	},
	["PALADIN"] = {
		{},
		{[1]="TANK_BUFFER"}, --Improved Devotion Aura -- Only matters if the pally is not a tank
		{}
	},
}

local currentRaidGroupIndexByName = {}

local currentRaidGroupRolesByIndex = {}

--list of subgroups by raid index
local currentRaidGroupPlacement = {}

local optimalRaidGroupPlacement = {}

--used for the "start over" button if an auto-arrange is forced to stop (someone leaves the raid etc)
local lastAction = {false, ""} -- [1] is true if the last action was a raid restore, and if so, [2] will be the name of the saved raid

local outdatedCheck = false

local delayedActionInProgress = false

local function cout(msg)
	if(DEFAULT_CHAT_FRAME and not GOMatic_Silent) then
		DEFAULT_CHAT_FRAME:AddMessage(loc.outputprefix .. msg, 0.0, 1.0, 0.0, 1.0);	
	end
end

local function dout(msg)
	if DEFAULT_CHAT_FRAME then
		DEFAULT_CHAT_FRAME:AddMessage("GOM DEBUG: " .. msg, 1.0, 0.0, 0.0, 1.0);	
	end
end

--ty to Aquendyn for this function
local function GetCmd(msg)
	if msg then
 		local a,b,c=strfind(msg, "(%S+)");
 		if a then
 			return c, strsub(msg, b+2);
 		else	
 			return "";
 		end
 	end
end

local function tremovebyval(tab, val)
	for k,v in pairs(tab) do
		if(v==val) then
			table.remove(tab, k)
			return true
		end
	end
	return false
end

local function BuildIndexByNameTable()
	for i=1, 40 do 
		currentRaidGroupIndexByName[GetRaidRosterInfo(i) or "-"]=i
	end
end

local PingReplies = {}

local function PingFrame_OnEvent()	
	if arg3 == "WHISPER" then
		if arg1 == "GOMPINGR" then
			table.insert(PingReplies, arg4)
			cout(arg4 .. ": " .. arg2 .. (arg2 ~= GOMatic_Version_String) and "**" or "")
		end
	end
end

local PingFrameDelay = 3
local PingFrameStartTime = 0

local function PingFrame_OnUpdate()
	if PingFrameStartTime + PingFrameDelay < time() then		
		if GetNumRaidMembers() > 1 then
			for i=1, 40 do
				n = (GetRaidRosterInfo(i))
				if n then
					if not tremovebyval(PingReplies, n) then
						cout(n .. ": " .. loc.notinstalled)
					end
				end
			end
		end
		delayedActionInProgress = false
		this:UnregisterEvent("CHAT_MSG_ADDON")
		this:SetScript("OnEvent", nil)
		this:SetScript("OnUpdate", nil)
		GOMatic_PingFrame = nil
	end
end

local function CreatePingFrame()
	PingReplies = {UnitName("player")}

	PingFrameStartTime = time()
	
	delayedActionInProgress = true
	local f = CreateFrame("Frame","GOMatic_PingFrame")
	f:SetScript("OnEvent", PingFrame_OnEvent)
	f:SetScript("OnUpdate", PingFrame_OnUpdate)
	f:RegisterEvent("CHAT_MSG_ADDON")
	f:Show()
end	

local function FindMemberID(n)
	if GetNumRaidMembers() > 1 then
		for i=1, 40 do
			if n == GetRaidRosterInfo(i) then
				return i
			end
		end
	end
	
	return false
end

function GOMatic_RSCommandHandler(msg)
	local cmd, sc = GetCmd(msg)	
	
	if not (cmd or sc) then
		return
	end
	
	BuildIndexByNameTable()
	
	local i1, i2 = currentRaidGroupIndexByName[cmd], currentRaidGroupIndexByName[sc]
	
	if i1 and i2 then
		SwapRaidSubgroup(i1, i2)
	end
end

function GOMatic_RMCommandHandler(msg)
	local cmd, sc = GetCmd(msg)
	
	sc = tonumber(sc)
	
	if not (cmd or sc) then
		return
	end
	
	if sc < 1 or sc > 8 then
		return
	end
	
	BuildIndexByNameTable()
	
	local i = currentRaidGroupIndexByName[cmd]
	
	if i then
		SetRaidSubgroup(i, sc)
	end
end

function GOMatic_SlashCommandHandler(msg)
	local cmd, sc = GetCmd(msg)

	if GetNumRaidMembers() < 2 then
		cout(loc.nopointerr)
		return
	end

	if cmd and string.lower(cmd) == loc.pingcmd then
		if delayedActionInProgress then
			cout(loc.pleasewaiterr)
			return
		end
		
		CreatePingFrame()
		SendAddonMessage("GOMPING", tostring(GOMatic_Version), "RAID")
	elseif cmd and string.lower(cmd) == loc.silentcmd then	
		GOMatic_Silent = not GOMatic_Silent
		cout(loc.unsilenced)
	elseif cmd and string.lower(cmd) == loc.surecmd then
		GOMatic_AlwaysSure = not GOMatic_AlwaysSure
		cout(GOMatic_AlwaysSure and loc.sureon or loc.sureoff)
	elseif cmd and string.lower(cmd) == loc.cancelcmd then
		if GOMatic_ArrangementFrame and GOMatic_ArrangementFrame:IsVisible() then
			delayedActionInProgress = false
			GOMatic_ArrangementFrame:SetScript("OnUpdate", nil)
			GOMatic_ArrangementFrame:SetScript("OnEvent", nil)
			GOMatic_ArrangementFrame = nil
			cout(loc.cancelled)
		end
	elseif cmd and string.lower(cmd) == loc.savecmd then
		if delayedActionInProgress then
			cout(loc.pleasewaiterr)
			return
		end
		if sc then			
			if GOMatic_SavedRaidLayouts[sc] then
				GOMatic_SaveName = sc
				StaticPopup_Show("GOMatic_DO_SAVE", sc)
			else
				GOMatic_SaveRaid(sc)
			end
		else
			cout(loc.mustenternameerr)
		end
	elseif cmd and string.lower(cmd) == loc.restorecmd then
		if delayedActionInProgress then
			cout(loc.pleasewaiterr)
			return
		end
		if sc then
			local n = GOMatic_SavedRaidLayouts[sc]
			if n then				
				lastAction = {true, sc}
				GOMatic_RestoreRaid(n)
			else
				cout(loc.mustenternameerr)
				cout(loc.thesearegoodnames)
				foreach(GOMatic_SavedRaidLayouts, function(k,v) cout(k) end)
			end
		else
			cout(loc.mustenternameerr)
			cout(loc.thesearegoodnames)
			foreach(GOMatic_SavedRaidLayouts, function(k,v) cout(k) end)
		end
	elseif cmd and string.lower(cmd) == loc.autocmd then
		if delayedActionInProgress then
			cout(loc.pleasewaiterr)
			return
		end
		lastAction = {false, ""}
		GOMatic_StartArrange()
	else
		cout(loc.help)
	end
end

function GOMatic_RolesToString(roles)
	local msg = "{"
	
	for i=1, 11 do
		local x = (roles[i]) and "true, " or "false, "
		msg = msg .. x
	end
	local x = (roles[12]) and "true}" or "false}"
	msg = msg .. x
	
	return msg
end

function GOMatic_OnEvent()
	if event == "VARIABLES_LOADED" then		
		cout(GOMatic_Version_String .. loc.loaded)
	elseif event == "RAID_ROSTER_UPDATE" then
		SendAddonMessage("GOMVER", tostring(GOMatic_Version), "RAID")
	elseif event == "CHAT_MSG_ADDON" then		
		if arg3 == "RAID" then
			if arg1 == "GOMPING" then
				SendAddonMessage("GOMPINGR", GOMatic_Version_String, "WHISPER", arg4)
			elseif arg1 == "GOMVER" then
				if tonumber(arg2) and tonumber(arg2) > GOMatic_Version and GOMatic_Version >= 1 then
					if not (outdatedCheck or InCombatLockdown() ) then
						StaticPopup_Show("GOMatic_OUTDATED")
						outdatedCheck = true
					end
				end
			elseif arg1 == "GOMTALENT" then
				local myRoles = GetMyRoles()
				if myRoles then
					SendAddonMessage("GOMTALENTR", GOMatic_RolesToString(myRoles), "WHISPER", arg4)
				else
					cout(loc.talentserr)
				end
			end
		end
	end
end

function GOMatic_OnLoad()
	StaticPopupDialogs["GOMatic_DO_ARRANGE"] = {
		text = loc.doarrangedialogtext,
		button1 = loc.buttonok,		
		button2 = loc.buttoncancel,
		OnAccept = function()			
			GOMatic_CreateArrangementFrame()
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1
	}
	
	StaticPopupDialogs["GOMatic_ERROR_TOOMANYFAILEDMOVES"] = {
		text = loc.toomanyfailedmovesdialogtext,
		button1 = loc.buttonok,		
		timeout = 30,
		whileDead = 1,
		hideOnEscape = 1
	}
	
	StaticPopupDialogs["GOMatic_DO_SAVE"] = {
		text = loc.dosavedialogtext,
		button1 = loc.buttonok,		
		button2 = loc.buttoncancel,
		OnAccept = function()
			GOMatic_SaveRaid(GOMatic_SaveName)
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1
	}
	
	StaticPopupDialogs["GOMatic_AUTO_ABORT"] = {
		text = loc.autoabortdialogtext,
		button1 = loc.buttonstartover,		
		button2 = loc.buttoncancel,
		OnAccept = function()
			GOMatic_StartOver()
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1
	}
	
	StaticPopupDialogs["GOMatic_OUTDATED"] = {
		text = loc.addonoutdateddialogtext,
		button1 = loc.buttonok,
		timeout = 30,
		whileDead = 1,
		hideOnEscape = 1
	}
	
	

	
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("CHAT_MSG_ADDON")
	this:RegisterEvent("RAID_ROSTER_UPDATE")
	
	SlashCmdList["GROUPOMATIC"] = GOMatic_SlashCommandHandler
	SLASH_GROUPOMATIC1 = "/groupomatic"
	SLASH_GROUPOMATIC2 = "/gom"
	
	SlashCmdList["GROUPOMATIC_RAID_MOVE"] = GOMatic_RMCommandHandler
	SLASH_GROUPOMATIC_RAID_MOVE1 = "/raidmove"
	SLASH_GROUPOMATIC_RAID_MOVE2 = "/rm"
	
	SlashCmdList["GROUPOMATIC_RAID_SWAP"] = GOMatic_RSCommandHandler
	SLASH_GROUPOMATIC_RAID_SWAP1 = "/raidswap"
	SLASH_GROUPOMATIC_RAID_SWAP2 = "/rs"
end

local function GetMyRoles()	
	local mainRole = {0,0,0,0,0} --counter: tank/heal/melee/ranged/spell
	local myClass = select(2, UnitClass("player"))	
	local roles = universalClassRoles[myClass]
	local x = talentsToMainRolesByClass[myClass]

	if GetNumTalentTabs() ~= 3 then
		return false
	end
	
	if GetNumTalents(1) ~= getn(x[1]) or GetNumTalents(2) ~= getn(x[2]) or GetNumTalents(3) ~= getn(x[3]) then
		return false
	end
	
	if not x then
		--player is a pure class, just find special roles
		mainRole = nil
		
		for i=1, 3 do    
			for j=1, GetNumTalents(i) do
				local _, _, _, _, rank, maxRank = GetTalentInfo(i,j)	
				--this finds special roles, like "tank_buffer" for pallies with imp devo or locks with imp imp. generally these roles are simply "preferred" ie those players will get picked first to be in the tank groups		
				if rank == maxRank then
					local r = talentsToSpecialRolesByClass[myClass][i][j]
					if r then
						roles[roleIndex[r] ] = true
					end
				end
			end
		end
	else
		--player is a hybrid class, find main role and special roles
		for i=1, 3 do    
			for j=1, GetNumTalents(i) do
				local _, _, _, _, rank, maxRank = GetTalentInfo(i,j)
				
				if rank == maxRank then
					--this tries to figure out the primary role of the player by counting the number of tanking vs healing vs dps talents they have			
					mainRole[x[i][j] ] = mainRole[x[i][j] ] + 1
					--this finds special roles, like "tank_buffer" for pallies with imp devo or locks with imp imp. generally these roles are simply "preferred" ie those players will get picked first to be in the tank groups
					local r = talentsToSpecialRolesByClass[myClass][i][j]
					if r then
						roles[roleIndex[r] ] = true
					end
				end
			end
		end	
	end
	
	if mainRole then
		local roleHighest, myMainRole = 0, 1
				
		for a=1, 5 do
			if mainRole[a] > roleHighest then
				roleHighest = mainRole[a]
				myMainRole = a
			end
		end
			
		roles[roleIndex[({"TANK", "HEALER", "MELEE_DPS", "RANGE_DPS", "SPELL_DPS"})[myMainRole] ] ] = true
	end
	
	return roles
end

local function GetAllRaidIDs()
	local allIDs = false

	for i=1, 40 do
		if GetRaidRosterInfo(i) then
			if not allIDs then
				allIDs = {[1]=i}
			else
				table.insert(allIDs, i)
			end
		end
	end
	
	return allIDs
end

local function FillInEmptyRoles(displayIfAnyWereEmpty) --if this is true DON'T display if any were empty
	local wereEmpty = false

	for i=1, 40 do
		if not currentRaidGroupRolesByIndex[i] and UnitExists("raid"..i) then
			currentRaidGroupRolesByIndex[i] = GOMatic_RolesByNameCache[UnitName("raid"..i)] or defaultClassRoles[select(2, UnitClass("raid"..i))]
			wereEmpty = true
		end
	end
	
	if wereEmpty and not displayIfAnyWereEmpty then
		cout(loc.filledinunknownroleswithdefaultsrunping)
	end
end

local function ArrangeManager()
	delayedActionInProgress = false

	optimalRaidGroupPlacement = {}

	FillInEmptyRoles()

	local optimalSetup = GOMatic_Arrange()
	
	if not optimalSetup then
		return
	end
	
	local g = 1;
	
	local group = optimalSetup[g]

	while group and group ~= {} do
		for i=1, 5 do
			if group[i] then
				optimalRaidGroupPlacement[group[i] ] = g;
			end
		end
		g = g + 1
		group = optimalSetup[g]

	end		

	if not GOMatic_AlwaysSure then
		StaticPopup_Show("GOMatic_DO_ARRANGE")
	else		
		GOMatic_CreateArrangementFrame()
	end
end

function GOMatic_StartOver()
	if lastAction[1] then
		local n = GOMatic_SavedRaidLayouts[lastAction[2]]
		if n then				
			GOMatic_RestoreRaid(n)
		end
	else
		GOMatic_StartArrange()
	end
end

local function BuildCurrentPlacementTable()
	for i=1, 40 do
		local x = select(3, GetRaidRosterInfo(i))
		if x and x > 0 and x < 9 then
			currentRaidGroupPlacement[i] = x
		else
			currentRaidGroupPlacement[i] = nil
		end
	end
end

function GOMatic_CreateArrangementFrame()
	BuildCurrentPlacementTable()
	
	GOMatic_ArrangementFrameLastUpdate = GetTime()
	GOMatic_ArrangementFrameBreakCounter = 0
	
	delayedActionInProgress = true
	local f = CreateFrame("Frame","GOMatic_ArrangementFrame")	
	f:SetScript("OnEvent", GOMatic_ArrangementFrame_OnEvent)
	f:SetScript("OnUpdate", GOMatic_ArrangementFrame_OnUpdate )
	f:RegisterEvent("CHAT_MSG_SYSTEM")
	f:Show()
end

local function IsValidSpec(spec)
	if type(spec) ~= "table" then
		return false
	end
	
	if getn(spec) ~= 12 then
		return false
	end	

	for i=1, 12 do
		if type(spec[i])~= "boolean" then
			return false
		end
	end
	
	return spec[roleIndex["TANK"]] or spec[roleIndex["HEALER"]] or spec[roleIndex["MELEE_DPS"]] or spec[roleIndex["RANGE_DPS"]] or spec[roleIndex["SPELL_DPS"]]
end

local function PlayerRespec(s1, s2)
	local msg = loc.playerhasrespecced

	if s2[roleIndex["TANK"]] and not s1[roleIndex["TANK"]] then
		msg = msg .. loc.spectank
	elseif s2[roleIndex["HEALER"]] and not s1[roleIndex["HEALER"]] then
		msg = msg .. loc.spechealer
	elseif (s2[roleIndex["MELEE_DPS"]] or s2[roleIndex["RANGE_DPS"]] or s2[roleIndex["SPELL_DPS"]]) and not (s1[roleIndex["MELEE_DPS"]] or s1[roleIndex["RANGE_DPS"]] or s1[roleIndex["SPELL_DPS"]]) then
		msg = msg .. loc.specdps
	else
		return nil
	end
	
	return msg
end

local function GetMaxGroups()
	local x = GetNumRaidMembers() / 5
	return math.ceil(x)
end

function GOMatic_RemoveFromCache(n)
	GOMatic_RolesByNameCache[n] = nil
end

function GOMatic_TalentRequest_OnEvent()
	if arg3 == "WHISPER" and arg1 == "GOMTALENTR" then		
		GOMatic_SpecRecieved = {}
		RunScript("GOMatic_SpecRecieved = " .. arg2)
		local spec = GOMatic_SpecRecieved
		
		if not IsValidSpec(spec) then
			return
		end
	
		currentRaidGroupRolesByIndex[currentRaidGroupIndexByName[arg4] ] = spec
		
		if GOMatic_RolesByNameCache[arg4] then
			local respec = PlayerRespec(GOMatic_RolesByNameCache[arg4], spec)
			if respec then
				cout(string.format(respec, arg4))
			end 
		end

		GOMatic_RolesByNameCache[arg4] = spec
	end
end

local function TalentRequest_OnUpdate()
	if GOMatic_TalentRequestStartTime + GOMatic_TalentRequestDelayMaximum < GetTime() then
		ArrangeManager()
		GOMatic_TalentRequestFrame:SetScript("OnEvent", nil)
		GOMatic_TalentRequestFrame:UnregisterEvent("CHAT_MSG_ADDON")
		GOMatic_TalentRequestFrame:SetScript("OnUpdate", nil)
		GOMatic_TalentRequestFrame = nil
	end
end

local function CreateTalentRequestFrame()
	GOMatic_TalentRequestStartTime = GetTime()

	delayedActionInProgress = true
	local f = CreateFrame("Frame","GOMatic_TalentRequestFrame")
	f:SetScript("OnUpdate", TalentRequest_OnUpdate)
	f:SetScript("OnEvent", GOMatic_TalentRequest_OnEvent)
	f:RegisterEvent("CHAT_MSG_ADDON")
	f:Show()

	SendAddonMessage("GOMTALENT", tostring(GOMatic_Version), "RAID")
end

local function BuildRolesByIndexTable()
	for i=1, 40 do
		currentRaidGroupRolesByIndex[i] = false
	end
end

local function FindWorkingGroup(optimalSetup)
	local group = -1
	
	if GetNumRaidMembers() == 0 then
		return -1
	end
	
	for i=1, GetMaxGroups() do
		if (not optimalSetup[i][1]) then
			group = i
			break
		end
	end
	
	if group == -1 then
		for i=1, 8 do
			if not optimalSetup[i][1] then
				return -1
			end
			if getn(optimalSetup[i]) < 5 then
				group = i
				break
			end
		end
	end
	
	return group
end

function GOMatic_StartArrange()
	if not IsRaidLeader() then
		cout(loc.notraidleadererror)
		return
	end
	
	GOMATIC_ARRANGE_BREAK = 0
	
	BuildIndexByNameTable()	
	BuildRolesByIndexTable()
	local myRoles = GetMyRoles()
	if not myRoles then
		cout(loc.talentserr)
		myRoles = defaultClassRoles[select(2,UnitClass("player"))]
	end
	currentRaidGroupRolesByIndex[currentRaidGroupIndexByName[UnitName("player")] ] = myRoles
	
	cout(loc.requestingtalents)	
	
	CreateTalentRequestFrame()	
end

--thanks to Mikk for this
local function tcount(tab)
	local n=0
	
	for _ in pairs(tab) do
		n=n+1
	end

	return n
end


local function IsGroupFull(group)
	local n = 0
	
	for i=1, 40 do
		if currentRaidGroupPlacement[i] and currentRaidGroupPlacement[i] == group then
			n = n + 1
		end
	end
		
	return n == 5
end

local function FindIDToMoveToGroup(group)
	if group == -1 then
		return nil
	end
	
	for i=1, 40 do
		local currentGroup = currentRaidGroupPlacement[i]
		local destGroup = optimalRaidGroupPlacement[i]
		
		if currentGroup and currentGroup > 0 and currentGroup < 9 and destGroup and destGroup ~= currentGroup and destGroup > 0 and destGroup < 9 and destGroup == group then
			return i
		end
	end		
	
	return nil
end

local function FindEmptySlot()
	for i=1, 8 do
		if not IsGroupFull(i) then			
			local x = FindIDToMoveToGroup(i)
			if x then
				return i, x
			end
		end
	end
		
	return -1, nil
end

function GOMatic_DisplayCurrAndDest()
	for i=1, 40 do
		currentGroup = currentRaidGroupPlacement[i]
		destGroup = optimalRaidGroupPlacement[i]
		local msg = ""
		if currentGroup then msg = currentGroup end
		if destGroup then msg = msg .. "     " .. destGroup end
		
		dout(msg)
	end
end

local function FindUnmovedID(ignoreGroup)
	local raidIDToMove, currentGroup, destGroup = nil, nil, nil
	
	for i=1, 40 do
		currentGroup = currentRaidGroupPlacement[i]
		destGroup = optimalRaidGroupPlacement[i]

		if currentGroup and currentGroup > 0 and currentGroup < 9 and (not (ignoreGroup and currentGroup == ignoreGroup)) and destGroup and destGroup ~= currentGroup and destGroup > 0 and destGroup < 9 then
			raidIDToMove = i
			break
		end
	end
	
	return raidIDToMove, currentGroup, destGroup
end

--return 41 if a complete match, raid id if a match except for spec AND requirePref is false, or false if not a good match
local function DoesIDMatchClassAndSpec(ID, class, prefSpec, requirePref, ignoreSpec)
	if type(currentRaidGroupRolesByIndex[ID]) ~= "table" or not IsValidSpec(currentRaidGroupRolesByIndex[ID]) then
		return false
	end
	
	local realSpec, realClass = currentRaidGroupRolesByIndex[ID], select(2, UnitClass("raid"..ID))
	
	local doesMatch = 41
	
	if class and realClass ~= class then
		return false
	end
	
	if not realSpec[prefSpec] then		
		if requirePref then
			return false
		end
	
		doesMatch = ID			
	end
	
	if ignoreSpec and realSpec == ignoreSpec then
		return false
	end	
	
	return doesMatch
end

local function FindInGroup(group, spec)
	for i = 1, getn(group) do
		if currentRaidGroupRolesByIndex[group[i] ][roleIndex[spec] ] then
			return true
		end
	end
	
	return false
end
local imtrue = true
function GOMatic_Arrange(optimalSetup, unassignedMembers, GOMuserTemplateToUse)
	if GOMATIC_ARRANGE_BREAK and GOMATIC_ARRANGE_BREAK > 100 then
		dout("Bad user template: Infinite loop terminated. Use a different template.")
		return false
	end
	
	local optimalSetup = optimalSetup or {{},{},{},{},{},{},{},{}}
		
	local unassignedMembers = unassignedMembers or GetAllRaidIDs()	
	
	local x = FindWorkingGroup(optimalSetup)

	if x == -1 or (not unassignedMembers[1]) then
		return optimalSetup
	end
	
	local group = optimalSetup[x]
		
	local match = false
	
	local class, prefSpec, requirePref, ignoreSpec = nil, nil, false, nil

	local lastMatch, lastIndex = -1, -1
	
	local usePreviousGroup = false
	
	local function HandleMatchup(i, v)
		if i == 1 then
			lastMatch = -1
			match = false
		end
		
		if not v then
dout("v nil")
			match = false
			return
		end
		
		local isMatch = DoesIDMatchClassAndSpec(v, class, prefSpec, requirePref, ignoreSpec)
		
		if isMatch then			
			if isMatch == 41 then
				match = true
				table.remove(unassignedMembers, i)
				if usePreviousGroup then
					table.insert(optimalSetup[x-1], v)
				else
					table.insert(group, v)
				end
			
				return true
			elseif lastMatch == -1 then
					lastMatch = v
					lastIndex = i
			end
		end
						
		if i == getn(unassignedMembers) and (not match) and lastMatch > 0 then
			match = true
			table.remove(unassignedMembers, lastIndex)
			if usePreviousGroup then
				table.insert(optimalSetup[x-1], lastMatch)
			else
				table.insert(group, lastMatch)
			end
			
			return true
		end
		
		--this shouldn't ever happen
		if i == getn(unassignedMembers) and match then
dout("end still match")
			match = false
		end
	end
	
	local function myForeachi(tab, func)
		if getn(tab) == 0 then
			match = false
		end
		for k, v in pairs(tab) do
			if func(k,v) then return end
		end
	end
	
	--[[ this is for future versions, it should let the addon accept user-created templates for group layouts

	if GOMuserTemplateToUse then
		if not group[1] then
			local template = GOMuserTemplateToUse[2]
		else
			local template = GOMuserTemplateToUse[3]
		end
		
		for tc=1, getn(template) do
			if type(template[tc]) == "string" then
				local cmd, sc = GetCmd(template[tc])
				if cmd and sc then
					if cmd == "fail" and not match then
						sc = tonumber(sc)
						if sc and sc > tc then
							tc = sc - 1
						end						
					elseif cmd == "end" then
						tc = getn(template)
					end
				end
			elseif type(template[tc]) == "table" then
				class, prefSpec, requirePref, ignoreSpec, loopWhile = template[tc][1], template[tc][2], template[tc][3], template[tc][4], template[tc][5]
				if prefSpec then
					prefSpec = roleIndex[prefSpec]
				end
				myForeachi(unassignedMembers, HandleMatchup)
				while loopWhile and tcount(group) < 5 and match do
					myForeachi(unassignedMembers, HandleMatchup)
				end
			end
		end

		optimalSetup[x] = group
		return GOMatic_Arrange(optimalSetup, unassignedMembers, GOMuserTemplateToUse)
	end
	
	]]
		
	if not group[1] then	
		--we're creating a new group
		--if there is a tank available, add it and
			--if there is another tank available, add it too
			--if there is a tree druid, add it
			--if there is a PALADIN that is not a tank and is a "tank buffer" available, add it
			--otherwise if there is a pally that isn't a tank available, add it
			--if there is a warlock that is a "tank buffer" available, add it, otherwise, if there is any other warlock available, add it			
			--stop
		--else if there is a healer available, add it and
			--if there is a mana battery, add it
			--if there is any free "heal buffer" add it
			--add as many other healers as there are free
			--stop
		--else if there is a melee dps available, add it and
			--if there is any melee buffer available, add it
			--find as many melee dps as are available, and add them
			--stop
		--else do the same as above for ranged and then spell dps
		
		
		class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["TANK"], true, nil
		myForeachi(unassignedMembers, HandleMatchup)
		if match then		
			class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["TANK"], true, nil
			myForeachi(unassignedMembers, HandleMatchup)
			--[[tree druids ... i dunno why i thought i needed to do it this way >.<
			if not match then
				class, prefSpec, requirePref, ignoreSpec = "DRUID", roleIndex["TANK_BUFFER"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			elseif x > 1 then
				usePreviousGroup = true
				class, prefSpec, requirePref, ignoreSpec = "DRUID", roleIndex["TANK_BUFFER"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
				if match and getn(optimalSetup[x-1]) == 6 then				
					for gc=1, 5 do
						if group[i] and currentRaidGroupRolesByIndex[group[i] ][roleIndex["TANK"] ] then
							table.insert(unassignedMembers,table.remove(group, i))
							break
						end
					end
					for gp=1, 6 do
						if optimalSetup[x-1][i] and currentRaidGroupRolesByIndex[optimalSetup[x-1][i] ][roleIndex["TANK"] ] then
							table.insert(group, table.remove(optimalSetup[x-1], i))
							break
						end
					end					
				end
				usePreviousGroup = false
			end
			--end tree druids]]
			
			class, prefSpec, requirePref, ignoreSpec = "DRUID", roleIndex["TANK_BUFFER"], true, roleIndex["TANK"]
			myForeachi(unassignedMembers, HandleMatchup)
			
			class, prefSpec, requirePref, ignoreSpec = "PALADIN", roleIndex["TANK_BUFFER"], false, roleIndex["TANK"]
			myForeachi(unassignedMembers, HandleMatchup)
			
			class, prefSpec, requirePref, ignoreSpec = "WARLOCK", roleIndex["TANK_BUFFER"], false, nil
			myForeachi(unassignedMembers, HandleMatchup)
		else
			class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["HEALER"], true, nil
			myForeachi(unassignedMembers, HandleMatchup)
			
			if match then
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MANA_BATTERY"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
				
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["HEAL_BUFFER"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
				
				match = true
				while tcount(group) < 5 and match do
					class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["HEALER"], true, nil
					myForeachi(unassignedMembers, HandleMatchup)
				end
			else
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_DPS"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
				
				if match then
					class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_BUFFER"], true, nil
					myForeachi(unassignedMembers, HandleMatchup)
				
					match = true
					while tcount(group) < 5 and match do
						class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_DPS"], true, nil
						myForeachi(unassignedMembers, HandleMatchup)
					end
				else
					class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["RANGE_DPS"], true, nil
					myForeachi(unassignedMembers, HandleMatchup)
				
					if match then
						class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["RANGE_BUFFER"], true, nil
						myForeachi(unassignedMembers, HandleMatchup)
				
						match = true
						while tcount(group) < 5 and match do
							class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["RANGE_DPS"], true, nil
							myForeachi(unassignedMembers, HandleMatchup)
						end
					else
						class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["SPELL_DPS"], true, nil
						myForeachi(unassignedMembers, HandleMatchup)
				
						if match then
							class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["SPELL_BUFFER"], true, nil
							myForeachi(unassignedMembers, HandleMatchup)
				
							match = true
							while tcount(group) < 5 and match do
								class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["SPELL_DPS"], true, nil
								myForeachi(unassignedMembers, HandleMatchup)
							end
						else
							cout(loc.arrangefailederr)							
							return false
						end
					end
				end
			end
		end
	else
		--we're filling in empty space
		--if there is a healer anywhere in the group
			--find any available heal buffers or mana batteries and add them
		--if there is a tank anywhere in the group
			--find any available tanks or tank buffers and add them
		--if there are any melee buffers in the group, add any available melee dps
		--if there are any ranged buffers in the group, add any available ranged dps and then melee dps
		--if there are any spell buffers in the group, add any available spell dps
		if FindInGroup(group, "HEALER") then
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["HEAL_BUFFER"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
			
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MANA_BATTERY"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
		end		
		if FindInGroup(group, "TANK") then
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["TANK_BUFFER"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
			
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["TANK"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
		end
		if FindInGroup(group, "MELEE_BUFFER") then
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_DPS"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
		end
		if FindInGroup(group, "RANGE_BUFFER") then
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["RANGE_DPS"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end		
		
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_DPS"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
		end
		--fill in any remaining spots with whatever is available		
		match = true
		while tcount(group) < 5 and match do								
			class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_DPS"], false, nil
			myForeachi(unassignedMembers, HandleMatchup)
		end
	end	
	optimalSetup[x] = group
	
	GOMATIC_ARRANGE_BREAK = GOMATIC_ARRANGE_BREAK + 1
	return GOMatic_Arrange(optimalSetup, unassignedMembers)
end

function GOMatic_RestoreRaid(restoreState)
	optimalRaidGroupPlacement = {}
	
	BuildRolesByIndexTable()
	BuildIndexByNameTable()	

	local myRoles = GetMyRoles()
	if not myRoles then
		cout(loc.talentserr)
		myRoles = defaultClassRoles[select(2,UnitClass("player"))]
	end
	currentRaidGroupRolesByIndex[currentRaidGroupIndexByName[UnitName("player")] ] = myRoles
	
	FillInEmptyRoles(1)
	
	local optimalSetup, unassignedMembers = {{},{},{},{},{},{},{},{}}, GetAllRaidIDs()
	
	local i, j, k = 0, 0, 0
	
	while i <= getn(unassignedMembers) do
		i = i + 1
		j=0
		while j <= 8 do
			j = j + 1
			k=0
			local z = restoreState[j]
			if not z then
				break
			end
			while k <= getn(z) do
				k = k + 1
				
				local y = z[k]
				if y and currentRaidGroupIndexByName[y] and (unassignedMembers[i] == currentRaidGroupIndexByName[y]) then
					table.insert(optimalSetup[j], table.remove(unassignedMembers, i))
					i = i - 1
					j, k = 9, 6
				end
			end			
		end
	end

	optimalSetup = GOMatic_Arrange(optimalSetup, unassignedMembers)
	
	if not optimalSetup then
		return
	end
	
	local g = 1;
	
	local group = optimalSetup[g]
	
	while group and group ~= {} do
		for i=1, 5 do
			if group[i] then
				optimalRaidGroupPlacement[group[i]] = g;
			end
		end
		g = g + 1
		group = optimalSetup[g]
	end		
	
	if not GOMatic_AlwaysSure then
		StaticPopup_Show("GOMatic_DO_ARRANGE")
	else
		GOMatic_CreateArrangementFrame()
	end
end

function GOMatic_SaveRaid(name)
	GOMatic_SaveName = nil

	local raid = {{},{},{},{},{},{},{},{}}
	
	for i=1, 40 do
		local n, _, g = GetRaidRosterInfo(i)
		if n then
			table.insert(raid[g], n)
		end		
	end
	
	GOMatic_SavedRaidLayouts[name] = raid
	
	cout(string.format(loc.raidsaved, name))
end

local function DoArrangement()
	if GOMatic_ArrangementFrameBreakCounter > GOMatic_ArrangementFrameBreakMaximum then
		StaticPopup_Show("GOMatic_ERROR_TOOMANYFAILEDMOVES")
		delayedActionInProgress = false
		GOMatic_ArrangementFrame:SetScript("OnUpdate", nil)
		GOMatic_ArrangementFrame:SetScript("OnEvent", nil)
		GOMatic_ArrangementFrame = nil
	end

	GOMatic_ArrangementFrameLastUpdate = GetTime()
	
	BuildCurrentPlacementTable()

	local emptySlot, raidIDToMove = FindEmptySlot()	

	if raidIDToMove then
		SetRaidSubgroup(raidIDToMove, emptySlot)		
		return true
	end
	
	local raidIDToMove, currentGroup, destGroup = FindUnmovedID()
	
	if not raidIDToMove then return false end
	
	local raidIDToMoveB = FindIDToMoveToGroup (currentGroup)
	
	if raidIDToMoveB then
		SwapRaidSubgroup(raidIDToMove, raidIDToMoveB)
	else
		raidIDToMoveB = FindUnmovedID(currentGroup)
		if not raidIDToMoveB then return false end
		
		SwapRaidSubgroup(raidIDToMove, raidIDToMoveB)
	end	
	
	return true
end

function GOMatic_RaidIsArranged()
	local isArranged = true
		
	if FindUnmovedID() then
		isArranged = false
	end
	
	if isArranged then
		cout(loc.arrangedone)
	end
	
	return isArranged
end

function GOMatic_ArrangementFrame_OnEvent()
	 if (arg1:match(ERR_RAID_MEMBER_REMOVED_S) or arg1:match(ERR_RAID_YOU_LEFT)) then
	 	StaticPopup_Show("GOMatic_AUTO_ABORT")
	 	delayedActionInProgress = false
	 	this:SetScript("OnUpdate", nil)
	 	this:UnregisterEvent("CHAT_MSG_SYSTEM")
	 	this:SetScript("OnEvent", nil)
	 	GOMatic_ArrangementFrame = nil
	 end
end

function GOMatic_ArrangementFrame_OnUpdate()
	if (GOMatic_ArrangementFrameUpdateThrottle + GOMatic_ArrangementFrameLastUpdate < GetTime()) then
		if GOMatic_RaidIsArranged() then
			delayedActionInProgress = false
			this:SetScript("OnUpdate", nil)
			this:UnregisterEvent("CHAT_MSG_SYSTEM")
			this:SetScript("OnEvent", nil)
			GOMatic_ArrangementFrame = nil
			return
		end
	
		local x = (DoArrangement()) and 0 or 1
		
		GOMatic_ArrangementFrameBreakCounter = GOMatic_ArrangementFrameBreakCounter + x
	end
end